'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _wrapDisplayName = require('recompose/wrapDisplayName');

var _wrapDisplayName2 = _interopRequireDefault(_wrapDisplayName);

var _shallowEqual = require('recompose/shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var defaultGetHeight = function defaultGetHeight() {
  var elem = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  if (elem && elem.getBoundingClientRect) {
    return elem.getBoundingClientRect().height;
  }
  if (elem) {
    return elem.clientHeight;
  }
  return null;
};

var defaultGetWidth = function defaultGetWidth() {
  var elem = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  if (elem && elem.getBoundingClientRect) {
    return elem.getBoundingClientRect().width;
  }
  if (elem) {
    return elem.clientWidth;
  }
  return null;
};

var defaultGetTop = function defaultGetTop() {
  var elem = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  if (elem && elem.getBoundingClientRect) {
    return elem.getBoundingClientRect().top;
  }
  if (elem) {
    return elem.clientTop;
  }
  return null;
};

var defaultGetLeft = function defaultGetLeft() {
  var elem = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  if (elem && elem.getBoundingClientRect) {
    return elem.getBoundingClientRect().left;
  }
  if (elem) {
    return elem.clientLeft;
  }
  return null;
};

var defaultGetViewportHeight = function defaultGetViewportHeight() {
  var _window = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var _document = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  if (_window || _document) {
    return _window.innerHeight || _document.clientHeight;
  }
  return null;
};

var defaultGetViewportWidth = function defaultGetViewportWidth() {
  var _window = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var _document = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  if (_window || _document) {
    return _window.innerWidth || _document.clientWidth;
  }
  return null;
};

var defaultTransform = function defaultTransform(_ref) {
  var inViewport = _ref.inViewport;
  return { inViewport: inViewport };
};

var defaultContainerStyle = {
  width: '100%',
  height: '100%',
  padding: 0,
  border: 0
};

function noop() {}

var withinViewport = function withinViewport() {
  var _ref2 = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var _ref2$transform = _ref2.transform;
  var transform = _ref2$transform === undefined ? defaultTransform : _ref2$transform;
  var _ref2$containerStyle = _ref2.containerStyle;
  var containerStyle = _ref2$containerStyle === undefined ? defaultContainerStyle : _ref2$containerStyle;
  var _ref2$getHeight = _ref2.getHeight;
  var getHeight = _ref2$getHeight === undefined ? defaultGetHeight : _ref2$getHeight;
  var _ref2$getWidth = _ref2.getWidth;
  var getWidth = _ref2$getWidth === undefined ? defaultGetWidth : _ref2$getWidth;
  var _ref2$getTop = _ref2.getTop;
  var getTop = _ref2$getTop === undefined ? defaultGetTop : _ref2$getTop;
  var _ref2$getLeft = _ref2.getLeft;
  var getLeft = _ref2$getLeft === undefined ? defaultGetLeft : _ref2$getLeft;
  var _ref2$getViewportHeig = _ref2.getViewportHeight;
  var getViewportHeight = _ref2$getViewportHeig === undefined ? defaultGetViewportHeight : _ref2$getViewportHeig;
  var _ref2$getViewportWidt = _ref2.getViewportWidth;
  var getViewportWidth = _ref2$getViewportWidt === undefined ? defaultGetViewportWidth : _ref2$getViewportWidt;
  var _ref2$defaultAnswer = _ref2.defaultAnswer;
  var defaultAnswer = _ref2$defaultAnswer === undefined ? true : _ref2$defaultAnswer;
  var _ref2$wait = _ref2.wait;
  var wait = _ref2$wait === undefined ? 200 : _ref2$wait;
  var _ref2$onViewportEnter = _ref2.onViewportEnter;
  var onViewportEnter = _ref2$onViewportEnter === undefined ? noop : _ref2$onViewportEnter;
  var _ref2$onViewportLeave = _ref2.onViewportLeave;
  var onViewportLeave = _ref2$onViewportLeave === undefined ? noop : _ref2$onViewportLeave;
  return function (BaseComponent) {
    var _class, _temp2;

    return _temp2 = _class = function (_Component) {
      _inherits(_class, _Component);

      function _class() {
        var _Object$getPrototypeO;

        var _temp, _this, _ret;

        _classCallCheck(this, _class);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(_class)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.state = {
          containerWidth: null,
          containerHeight: null,
          containerTopOffset: null,
          containerLeftOffset: null,
          windowWidth: null,
          windowHeight: null,
          ready: false
        }, _this.updateResize = function () {
          if (!_this.mounted) {
            return;
          }

          var update = function update() {
            var elem = _this.refs.withinViewportContainer;

            var newState = {
              containerWidth: getWidth(elem),
              containerHeight: getHeight(elem),
              windowWidth: getViewportWidth(window, document),
              windowHeight: getViewportHeight(window, document)
            };

            _this.setState(_extends({}, newState, { ready: _this.isReady(_extends({}, _this.state, newState)) }));
          };

          if (typeof window !== 'undefined' && window !== null && window.requestAnimationFrame) {
            window.requestAnimationFrame(function () {
              return update();
            });
          } else {
            update();
          }
        }, _this.updateScroll = function () {
          if (!_this.mounted) {
            return;
          }

          var update = function update() {
            var elem = _this.refs.withinViewportContainer;

            var newState = {
              containerTopOffset: getTop(elem),
              containerLeftOffset: getLeft(elem)
            };
            _this.setState(_extends({}, newState, { ready: _this.isReady(_extends({}, _this.state, newState)) }));
          };

          if (typeof window !== 'undefined' && window !== null && window.requestAnimationFrame) {
            window.requestAnimationFrame(function () {
              return update();
            });
          } else {
            update();
          }
        }, _this.isReady = function () {
          var state = arguments.length <= 0 || arguments[0] === undefined ? _this.state : arguments[0];
          return state.containerWidth !== null && state.containerHeight !== null && state.containerTopOffset !== null && state.containerLeftOffset !== null && state.windowHeight !== null && state.windowWidth !== null;
        }, _this.inViewport = function () {
          var state = arguments.length <= 0 || arguments[0] === undefined ? _this.state : arguments[0];

          if (state.ready) {
            return (state.containerTopOffset < 0 && state.containerHeight + state.containerTopOffset > 0 || state.containerTopOffset >= 0 && state.containerTopOffset < state.windowHeight) && (state.containerLeftOffset < 0 && state.containerWidth + state.containerLeftOffset > 0 || state.containerLeftOffset >= 0 && state.containerLeftOffset < state.windowWidth);
          }
          return defaultAnswer;
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(_class, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          if (typeof window !== 'undefined' && window !== null && window.addEventListener) {
            this.mounted = true;
            this.debouncedUpdateResize = (0, _lodash2.default)(this.updateResize, wait);
            this.debouncedUpdateScroll = (0, _lodash2.default)(this.updateScroll, wait);
            window.addEventListener('resize', this.debouncedUpdateResize, { passive: true });
            window.addEventListener('scroll', this.debouncedUpdateScroll, { passive: true });
            this.updateResize();
            this.updateScroll();
          }
        }
      }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
          var was = this.inViewport(prevState);
          var is = this.inViewport(this.state);

          if (prevState.ready === null && is === false) {
            onViewportLeave();
          }
          if (prevState.ready === null && is === true) {
            onViewportEnter();
          }
          if (was === true && is === false) {
            onViewportLeave();
          }
          if (was === false && is === true) {
            onViewportEnter();
          }
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          if (typeof window !== 'undefined' && window !== null && window.removeEventListener) {
            this.mounted = false;
            window.removeEventListener('resize', this.debouncedUpdateResize, { passive: true });
            window.removeEventListener('scroll', this.debouncedUpdateScroll, { passive: true });
          }
        }
      }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
          return !(0, _shallowEqual2.default)(this.props, nextProps) || !(0, _shallowEqual2.default)(transform(_extends({ inViewport: this.inViewport(this.state) }, this.state)), transform(_extends({ inViewport: this.inViewport(nextState) }, nextState)));
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(
            'div',
            {
              ref: 'withinViewportContainer',
              style: containerStyle
            },
            _react2.default.createElement(BaseComponent, _extends({}, transform(_extends({ inViewport: this.inViewport() }, this.state)), this.props))
          );
        }
      }]);

      return _class;
    }(_react.Component), _class.displayName = (0, _wrapDisplayName2.default)(BaseComponent, 'withinViewport'), _temp2;
  };
};

exports.default = withinViewport;